/**
 * @name csv-split-easy
 * @fileoverview Splits the CSV string into array of arrays, each representing a row of columns
 * @version 7.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/csv-split-easy/}
 */

"use strict";var csvSplitEasy=(()=>{var v=Object.defineProperty;var Ae=Object.getOwnPropertyDescriptor;var Ie=Object.getOwnPropertyNames,W=Object.getOwnPropertySymbols;var C=Object.prototype.hasOwnProperty,Re=Object.prototype.propertyIsEnumerable;var R=(e,o,a)=>o in e?v(e,o,{enumerable:!0,configurable:!0,writable:!0,value:a}):e[o]=a,d=(e,o)=>{for(var a in o||(o={}))C.call(o,a)&&R(e,a,o[a]);if(W)for(var a of W(o))Re.call(o,a)&&R(e,a,o[a]);return e};var Ne=(e,o)=>{for(var a in o)v(e,a,{get:o[a],enumerable:!0})},Ee=(e,o,a,s)=>{if(o&&typeof o=="object"||typeof o=="function")for(let l of Ie(o))!C.call(e,l)&&l!==a&&v(e,l,{get:()=>o[l],enumerable:!(s=Ae(o,l))||s.enumerable});return e};var $e=e=>Ee(v({},"__esModule",{value:!0}),e);var N=(e,o,a)=>(R(e,typeof o!="symbol"?o+"":o,a),a);var Hr={};Ne(Hr,{defaults:()=>we,splitEasy:()=>Pr,version:()=>Mr});var je={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function y(e,o){if(!Array.isArray(e)||!e.length)return e;let a=d(d({},je),o),s,l;if(a.strictlyTwoElementsInRangeArrays&&!e.every((i,f)=>!Array.isArray(i)||i.length!==2?(s=f,l=i.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) has not two but ${l} elements!`);if(!e.every((i,f)=>!Array.isArray(i)||!Number.isInteger(i[0])||i[0]<0||!Number.isInteger(i[1])||i[1]<0?(s=f,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) does not consist of only natural numbers!`);let r=e.length**2,n=0;return Array.from(e).sort((i,f)=>(a.progressFn&&(n+=1,a.progressFn(Math.floor(n*100/r))),i[0]===f[0]?i[1]<f[1]?-1:i[1]>f[1]?1:0:i[0]<f[0]?-1:1))}var _={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function k(e,o){function a(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let s;if(o)if(a(o)){if(s=d(d({},_),o),s.progressFn&&a(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(o,null,4)} (type ${typeof o})`);else s=d({},_);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,n,i;s.progressFn?r=y(l,{progressFn:t=>{i=Math.floor(t/5),i!==n&&(n=i,s.progressFn(i))}}):r=y(l);let f=r.length-1;for(let t=f;t>0;t--)s.progressFn&&(i=Math.floor((1-t/f)*78)+21,i!==n&&i>n&&(n=i,s.progressFn(i))),(r[t][0]<=r[t-1][0]||!s.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||s.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+s.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var Fe=!0,E="Invariant failed";function B(e,o){if(!e){if(Fe)throw new Error(E);var a=typeof o=="function"?o():o,s=a?"".concat(E,": ").concat(a):E;throw new Error(s)}}function J(e,o,a){let s=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(o&&!Array.isArray(o))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(a&&typeof a!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof a}, equal to: ${JSON.stringify(a,null,4)}`);if(!(o!=null&&o.filter(u=>u).length))return e;let r;Array.isArray(o)&&Number.isInteger(o[0])&&Number.isInteger(o[1])?r=[Array.from(o)]:r=Array.from(o);let n=r.length,i=0;r.filter(u=>u).forEach((u,p)=>{if(a&&(s=Math.floor(i/n*10),s!==l&&(l=s,a(s))),!Array.isArray(u))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${p}th element not an array: ${JSON.stringify(u,null,4)}, which is ${typeof u}`);if(!Number.isInteger(u[0])){if(!Number.isInteger(+u[0])||+u[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(u,null,0)}. Its first element is not an integer, string index, but ${typeof u[0]}, equal to: ${JSON.stringify(u[0],null,4)}.`);r[p][0]=+r[p][0]}if(!Number.isInteger(u[1])){if(!Number.isInteger(+u[1])||+u[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(u,null,0)}. Its second element is not an integer, string index, but ${typeof u[1]}, equal to: ${JSON.stringify(u[1],null,4)}.`);r[p][1]=+r[p][1]}i+=1});let f=k(r,{progressFn:u=>{a&&(s=10+Math.floor(u/10),s!==l&&(l=s,a(s)))}});B(f);let t=f.length;if(t>0){let u=e.slice(f[t-1][1]);e=f.reduce((p,g,m,T)=>{a&&(s=20+Math.floor(m/t*80),s!==l&&(l=s,a(s)));let ve=m===0?0:T[m-1][1],Oe=T[m][0];return`${p}${e.slice(ve,Oe)}${T[m][2]||""}`},""),e+=u}return e}function O(e,o=1){let a="\xA0";function s(r){return Array.from(r).reverse().join("")}function l(r,n,i){let f=i?`
`:"\r",t=i?"\r":`
`;if(!r)return r;let u=0,p=0,g="";for(let m=0,T=r.length;m<T;m++)(r[m]===f||r[m]===t&&r[m-1]!==f)&&p++,`\r
`.includes(r[m])||r[m]===a?(u=0,r[m]===a?g+=r[m]:r[m]===f?p<=n&&(g+=r[m],r[m+1]===t&&(g+=r[m+1],m++)):r[m]===t&&(r==null?void 0:r[m-1])!==f&&p<=n&&(g+=r[m])):(u++,!r[m+1]&&!p&&(g+=" "));return g}if(typeof e=="string"&&e.length){let r=1;typeof+o=="number"&&Number.isInteger(+o)&&+o>=0&&(r=+o);let n="",i="";if(!e.trim())n=e;else if(!e[0].trim()){for(let f=0,t=e.length;f<t;f++)if(e[f].trim()){n=e.slice(0,f);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===a)){for(let f=e.length;f--;)if(e[f].trim()){i=e.slice(f+1);break}}return`${l(n,r,!1)}${e.trim()}${s(l(s(i),r,!0))}`}return e}function b(e){return typeof e=="string"}function x(e){return Number.isSafeInteger(e)&&e>=0}function c(e){return e!=null}var M={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function De(e,o){function a(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let s;if(o)if(a(o)){if(s=d(d({},M),o),s.progressFn&&a(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(o,null,4)} (type ${typeof o})`);else s=d({},M);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,n,i;s.progressFn?r=y(l,{progressFn:t=>{i=Math.floor(t/5),i!==n&&(n=i,s.progressFn(i))}}):r=y(l);let f=r.length-1;for(let t=f;t>0;t--)s.progressFn&&(i=Math.floor((1-t/f)*78)+21,i!==n&&i>n&&(n=i,s.progressFn(i))),(r[t][0]<=r[t-1][0]||!s.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||s.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+s.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var We={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},P=class{constructor(e){N(this,"ranges");N(this,"opts");let o=d(d({},We),e);if(o.mergeType&&o.mergeType!==1&&o.mergeType!==2)if(b(o.mergeType)&&o.mergeType.trim()==="1")o.mergeType=1;else if(b(o.mergeType)&&o.mergeType.trim()==="2")o.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof o.mergeType}", equal to ${JSON.stringify(o.mergeType,null,4)}`);this.opts=o,this.ranges=[]}add(e,o,a){var r;if(e==null&&o==null)return;if(c(e)&&!c(o)){if(Array.isArray(e)){if(e.length){if(e.some(n=>Array.isArray(n))){e.forEach(n=>{Array.isArray(n)&&this.add(...n)});return}e.length&&x(+e[0])&&x(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(o,null,0)})`)}else if(!c(e)&&c(o))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(o,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let s=+e,l=+o;if(x(a)&&(a=String(a)),x(s)&&x(l)){if(c(a)&&!b(a)&&!x(a))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof a}, equal to:
${JSON.stringify(a,null,4)}`);if(c(this.ranges)&&Array.isArray(this.last())&&s===this.last()[1]){if(this.last()[1]=l,this.last()[2],this.last()[2]!==null&&c(a)){let n=this.last()[2]&&this.last()[2].length&&(!((r=this.opts)!=null&&r.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${a}`:a;this.opts.limitToBeAddedWhitespace&&(n=O(n,this.opts.limitLinebreaksCount)),b(n)&&!n.length||(this.last()[2]=n)}}else{this.ranges||(this.ranges=[]);let n=a!==void 0&&!(b(a)&&!a.length)?[s,l,a&&this.opts.limitToBeAddedWhitespace?O(a,this.opts.limitLinebreaksCount):a]:[s,l];this.ranges.push(n)}}else throw x(s)&&s>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof s}" equal to: ${JSON.stringify(s,null,4)}`)}push(e,o,a){this.add(e,o,a)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=De(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>c(e[2])?[e[0],e[1],O(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&x(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var Ce=typeof global=="object"&&global&&global.Object===Object&&global,H=Ce;var _e=typeof self=="object"&&self&&self.Object===Object&&self,ke=H||_e||Function("return this")(),q=ke;var Be=q.Symbol,h=Be;var L=Object.prototype,Je=L.hasOwnProperty,Me=L.toString,S=h?h.toStringTag:void 0;function Pe(e){var o=Je.call(e,S),a=e[S];try{e[S]=void 0;var s=!0}catch(r){}var l=Me.call(e);return s&&(o?e[S]=a:delete e[S]),l}var U=Pe;var He=Object.prototype,qe=He.toString;function Le(e){return qe.call(e)}var K=Le;var Ue="[object Null]",Ke="[object Undefined]",z=h?h.toStringTag:void 0;function ze(e){return e==null?e===void 0?Ke:Ue:z&&z in Object(e)?U(e):K(e)}var V=ze;function Ve(e){return e!=null&&typeof e=="object"}var Q=Ve;var Qe="[object Symbol]";function Ge(e){return typeof e=="symbol"||Q(e)&&V(e)==Qe}var G=Ge;function Ze(e,o){for(var a=-1,s=e==null?0:e.length,l=Array(s);++a<s;)l[a]=o(e[a],a,e);return l}var Z=Ze;var Ye=Array.isArray,Y=Ye;var Xe=1/0,X=h?h.prototype:void 0,ee=X?X.toString:void 0;function re(e){if(typeof e=="string")return e;if(Y(e))return Z(e,re)+"";if(G(e))return ee?ee.call(e):"";var o=e+"";return o=="0"&&1/e==-Xe?"-0":o}var A=re;var er=/\s/;function rr(e){for(var o=e.length;o--&&er.test(e.charAt(o)););return o}var te=rr;var tr=/^\s+/;function or(e){return e&&e.slice(0,te(e)+1).replace(tr,"")}var oe=or;function ar(e,o,a,s){for(var l=e.length,r=a+(s?1:-1);s?r--:++r<l;)if(o(e[r],r,e))return r;return-1}var ae=ar;function sr(e){return e!==e}var se=sr;function fr(e,o,a){for(var s=a-1,l=e.length;++s<l;)if(e[s]===o)return s;return-1}var fe=fr;function nr(e,o,a){return o===o?fe(e,o,a):ae(e,se,a)}var I=nr;function lr(e){return e==null?"":A(e)}var ne=lr;function ir(e,o,a){var s=-1,l=e.length;o<0&&(o=-o>l?0:l+o),a=a>l?l:a,a<0&&(a+=l),l=o>a?0:a-o>>>0,o>>>=0;for(var r=Array(l);++s<l;)r[s]=e[s+o];return r}var le=ir;function ur(e,o,a){var s=e.length;return a=a===void 0?s:a,!o&&a>=s?e:le(e,o,a)}var ie=ur;var pr="\\ud800-\\udfff",mr="\\u0300-\\u036f",dr="\\ufe20-\\ufe2f",gr="\\u20d0-\\u20ff",xr=mr+dr+gr,cr="\\ufe0e\\ufe0f",hr="\\u200d",yr=RegExp("["+hr+pr+xr+cr+"]");function br(e){return yr.test(e)}var ue=br;function Tr(e){return e.split("")}var pe=Tr;var me="\\ud800-\\udfff",Sr="\\u0300-\\u036f",wr="\\ufe20-\\ufe2f",vr="\\u20d0-\\u20ff",Or=Sr+wr+vr,Ar="\\ufe0e\\ufe0f",Ir="["+me+"]",$="["+Or+"]",j="\\ud83c[\\udffb-\\udfff]",Rr="(?:"+$+"|"+j+")",de="[^"+me+"]",ge="(?:\\ud83c[\\udde6-\\uddff]){2}",xe="[\\ud800-\\udbff][\\udc00-\\udfff]",Nr="\\u200d",ce=Rr+"?",he="["+Ar+"]?",Er="(?:"+Nr+"(?:"+[de,ge,xe].join("|")+")"+he+ce+")*",$r=he+ce+Er,jr="(?:"+[de+$+"?",$,ge,xe,Ir].join("|")+")",Fr=RegExp(j+"(?="+j+")|"+jr+$r,"g");function Dr(e){return e.match(Fr)||[]}var ye=Dr;function Wr(e){return ue(e)?ye(e):pe(e)}var F=Wr;function Cr(e,o){for(var a=e.length;a--&&I(o,e[a],0)>-1;);return a}var be=Cr;function _r(e,o){for(var a=-1,s=e.length;++a<s&&I(o,e[a],0)>-1;);return a}var Te=_r;function kr(e,o,a){if(e=ne(e),e&&(a||o===void 0))return oe(e);if(!e||!(o=A(o)))return e;var s=F(e),l=F(o),r=Te(s,l),n=be(s,l)+1;return ie(s,r,n).join("")}var D=kr;var Br={removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1};function w(e,o){let a=!0,s=[".",",","'"," "],l;if(typeof e!="string")throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_01] Input must be string! Currently it's: ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);if(o&&typeof o!="object")throw new TypeError(`string-remove-thousand-separators/remSep(): [THROW_ID_02] Options object must be a plain object! Currently it's: ${typeof o}, equal to:
${JSON.stringify(o,null,4)}`);let r=d(d({},Br),o),n=D(e.trim(),'"');if(n==="")return n;if(+e>0&&+e<1)return e;let i=new P;for(let f=0,t=n.length;f<t;f++){if(r.removeThousandSeparatorsFromNumbers&&n[f].trim()===""&&i.add(f,f+1),r.removeThousandSeparatorsFromNumbers&&n[f]==="'"&&(i.add(f,f+1),n[f+1]==="'")){a=!1;break}if(s.includes(n[f])){if(n[f+1]!==void 0&&/^\d$/.test(n[f+1]))if(n[f+2]!==void 0)if(/^\d$/.test(n[f+2]))if(n[f+3]!==void 0)if(/^\d$/.test(n[f+3])){if(n[f+4]!==void 0&&/^\d$/.test(n[f+4])){a=!1;break}else if(r.removeThousandSeparatorsFromNumbers&&i.add(f,f+1),!l)l=n[f];else if(n[f]!==l){a=!1;break}}else{a=!1;break}else r.removeThousandSeparatorsFromNumbers&&r.forceUKStyle&&n[f]===","&&i.add(f,f+1,".");else{a=!1;break}else r.forceUKStyle&&n[f]===","&&i.add(f,f+1,"."),r.padSingleDecimalPlaceNumbers&&i.add(f+2,f+2,"0")}else if(!/^\d$/.test(n[f])){a=!1;break}}return a&&i.current()?J(n,i.current()):n}var Se="7.0.9";var Mr=Se,we={removeThousandSeparatorsFromNumbers:!0,padSingleDecimalPlaceNumbers:!0,forceUKStyle:!1};function Pr(e,o){let a=0,s=0,l=[],r=[],n=!1,i=!0;if(o&&typeof o!="object")throw new Error(`csv-split-easy/split(): [THROW_ID_02] Options object must be a plain object! Currently it's of a type ${typeof o} equal to:
${JSON.stringify(o,null,4)}`);let f=d(d({},we),o);if(typeof e!="string")throw new TypeError(`csv-split-easy/split(): [THROW_ID_04] input must be string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(e==="")return[[""]];e=e.trim();for(let t=0,u=e.length;t<u;t++){if(i&&e[t]!=='"'&&e[t]!==","&&e[t].trim()!==""&&(i=!1),e[t]==='"')if(n&&e[t+1]==='"')t+=1;else if(n){n=!1;let p=e.slice(a,t);p.trim()!==""&&(i=!1);let g=/""/.test(p)?p.replace(/""/g,'"'):w(p,{removeThousandSeparatorsFromNumbers:f.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:f.padSingleDecimalPlaceNumbers,forceUKStyle:f.forceUKStyle});l.push(g)}else n=!0,a=t+1;else if(!n&&e[t]===","){if(e[t-1]!=='"'&&!n){let p=e.slice(a,t);p.trim()!==""&&(i=!1),l.push(w(p,{removeThousandSeparatorsFromNumbers:f.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:f.padSingleDecimalPlaceNumbers,forceUKStyle:f.forceUKStyle}))}a=t+1,s&&(s=0)}else if(e[t]===`
`||e[t]==="\r"){if(!s){if(s=t,!n&&e[t-1]!=='"'){let p=e.slice(a,t);p.trim()!==""&&(i=!1),l.push(w(p,{removeThousandSeparatorsFromNumbers:f.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:f.padSingleDecimalPlaceNumbers,forceUKStyle:f.forceUKStyle}))}i?l.length=0:r.push(l),i=!0,l=[]}a=t+1}else s&&(s=0,a=t);if(t+1===u){if(e[t]!=='"'){let p=e.slice(a,t+1);p.trim()&&(i=!1),l.push(w(p,{removeThousandSeparatorsFromNumbers:f.removeThousandSeparatorsFromNumbers,padSingleDecimalPlaceNumbers:f.padSingleDecimalPlaceNumbers,forceUKStyle:f.forceUKStyle}))}i?l=[]:r.push(l),i=!0}}return r.length===0?[[""]]:r}return $e(Hr);})();
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.5.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name string-remove-thousand-separators
 * @fileoverview Detects and removes thousand separators (dot/comma/quote/space) from string-type digits
 * @version 7.0.9
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-thousand-separators/}
 */
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)
*/
